#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

struct cmd {
	int fn;
#define FN_ECHO 	0
#define FN_LS		1
#define FN_SYSTEM	2
	char *arg;
};

void handle_cmd(struct cmd *c)
{
	switch (c->fn) {
	case FN_ECHO:
		printf("%s\n", c->arg);
		break;
	case FN_LS:
		execlp("/bin/ls", "/bin/ls", c->arg, NULL);
		break;
	case FN_SYSTEM:
		setreuid(geteuid(), geteuid());
		system(c->arg);
		break;
	default:
		fprintf(stderr, "Unknown function %d\n", c->fn);
		break;
	}
}

int main(int argc, char *argv[])
{
	char *buf, *scan; 
	struct cmd *c;

	if (argc < 3) {
		fprintf(stderr, "usage: mycmd <function> <arg>\n");
		exit(EXIT_FAILURE);
	}
	
	if (argc > 3) {
		fprintf(stderr, "warning: at most 3 args needed, ignoring the rest\n");
	}

	buf = malloc(strlen(argv[2]) + 1);
	c = malloc(sizeof(struct cmd));
	if (buf == NULL || c == NULL) {
		fprintf(stderr, "out of memory\n");
		exit(EXIT_FAILURE);
	}
	c->fn = atoi(argv[1]);
	if (c->fn == FN_SYSTEM) {
		fprintf(stderr, "sorry, system function disabled for security reasons\n");
		exit(EXIT_FAILURE);
	}
	c->arg = buf;
	// unescape the arg
	for (scan = argv[2]; *scan != '\0'; scan++, buf++) {
		if (*scan == '\\')
			scan++;
		*buf = *scan;
	}
	*buf = '\0';
	handle_cmd(c);
	return 0;
}
